* PROGRAM:  VST.PRG
* FUNCTION: VALIDATE STATE CODE
*           if valid, displays state name and numeric code on line 24
*           INCLUDES CALL TO A POP UP BOX
* Maurice Frank


PARAMETERS MGET_ROW, MGET_COL


PRIVATE MVALID

MVALID = .F.

IF LEN(LTRIM(TRIM(MST))) = 0 .OR. "?" $ MST .OR. "/" $ MST
   * st code is blank or user typed ? or / to request pop up

   MST_POP = ""                                    && this must be here!
   MNAME_R = ""                                    && indirect return of vstpop

   MST_POP = VSTPOP(04,46,16)                      && POP UP BOX CALLED HERE!

   IF LEN(LTRIM(TRIM(MST_POP))) > 0
      * user selected something; display state name
      SET COLOR TO N/W
      @ MGET_ROW,MGET_COL SAY MST_POP
      SET COLOR TO
      @ 24,00
      * state number appended to name return var; name is 15 char long
      ?? "STATE: " + MST_POP + SPACE(2) + LEFT(MNAME_R,LEN(MNAME_R)-2) + "  (#" + RIGHT(MNAME_R,2) + ")"
      MVALID = .T.
   ELSE
      * no selection
      @ 24,00
      ?? CHR(07) + "You must enter or select a state code; ESCape to cancel input"
      MVALID = .F.
   ENDIF

ELSE

   * something was entered (except ? or /) - validate from table

   MAREA = STR(SELECT(),2)
   SELECT 0
   USE STATES INDEX STATES
   SEEK MST
   MVALID = FOUND()
   IF .NOT. MVALID
      @ 24,00
      ?? CHR(07) + "State code not found in table."
   ELSE
      @ 24,00
      ?? "STATE: " + MST + SPACE(2) + NAME + "  (#" + CODE + ")"
   ENDIF
   USE
   SELECT &MAREA

ENDIF

RETURN MVALID

